# Vue IP Highlighter

IP地址检测和信息显示组件

## 安装

```bash
npm install vue-ip-highlighter
```

## 使用方法

### 方式一：全局注册

```javascript
import { createApp } from 'vue'
import App from './App.vue'
import IPHighlighterPlugin from 'vue-ip-highlighter'

const app = createApp(App)
app.use(IPHighlighterPlugin)
app.mount('#app')
```

### 方式二：局部注册

```vue
<template>
  <div>
    <IPHighlighter>
      <!-- 需要检测IP的内容 -->
      <div>
        这里是需要检测IP的内容
        例如：192.168.1.1
      </div>
    </IPHighlighter>
  </div>
</template>

<script>
import { IPHighlighter } from 'vue-ip-highlighter'

export default {
  components: {
    IPHighlighter
  }
}
</script>
```

## Props

| 属性名 | 类型 | 默认值 | 说明 |
|--------|------|--------|------|
| apiUrl | String | https://your-api.com/ip | API地址 |
| requestConfig | Object | { credentials: 'include' } | 请求配置 |

## License

MIT
