import { openBlock as p, createElementBlock as h, renderSlot as v, withDirectives as T, createElementVNode as c, normalizeStyle as E, toDisplayString as f, Fragment as y, renderList as w, vShow as x } from "vue";
const C = (e, t) => {
  const o = e.__vccOpts || e;
  for (const [i, s] of t)
    o[i] = s;
  return o;
}, N = {
  name: "IPHighlighter",
  props: {
    // API 基础URL
    apiUrl: {
      type: String,
      default: "https://cmdb.google.com/api/v2/get_env_by_ip"
    },
    // 自定义请求配置
    requestConfig: {
      type: Object,
      default: () => ({
        credentials: "include",
        headers: {
          Accept: "application/json",
          "Content-Type": "application/json"
        }
      })
    }
  },
  data() {
    return {
      showTooltip: !1,
      currentIP: null,
      ipInfo: null,
      tooltipStyle: {
        left: "0px",
        top: "0px"
      },
      // IP地址正则表达式
      ipRegex: /\b(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b/g
    };
  },
  mounted() {
    this.highlightIPs(), this.observeDOMChanges(), document.addEventListener("click", this.handleClickOutside);
  },
  beforeDestroy() {
    document.removeEventListener("click", this.handleClickOutside);
  },
  methods: {
    highlightIPs() {
      const e = this.$el, t = document.createTreeWalker(
        e,
        NodeFilter.SHOW_TEXT,
        {
          acceptNode: (i) => i.parentElement && ["SCRIPT", "STYLE", "TEXTAREA", "INPUT"].includes(i.parentElement.tagName) ? NodeFilter.FILTER_REJECT : i.textContent.match(this.ipRegex) ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_REJECT
        }
      ), o = [];
      for (; t.nextNode(); )
        o.push(t.currentNode);
      o.forEach((i) => {
        const s = i.parentNode, r = i.textContent, l = document.createDocumentFragment();
        let n = 0;
        const m = r.matchAll(this.ipRegex);
        for (const _ of m) {
          const d = _[0], u = _.index;
          u > n && l.appendChild(document.createTextNode(r.slice(n, u)));
          const a = document.createElement("span");
          a.className = "ip-highlight", a.textContent = d, a.addEventListener("mouseenter", (I) => this.showIPInfo(d, I)), a.addEventListener("mouseleave", this.handleMouseLeave), l.appendChild(a), n = u + d.length;
        }
        n < r.length && l.appendChild(document.createTextNode(r.slice(n))), s.replaceChild(l, i);
      });
    },
    async showIPInfo(e, t) {
      this.currentIP = e, this.ipInfo = null, this.updateTooltipPosition(t), this.showTooltip = !0;
      try {
        const i = await (await fetch(`${this.apiUrl}?ip=${e}`, this.requestConfig)).json();
        this.ipInfo = i;
      } catch (o) {
        console.error("获取IP信息失败:", o), this.ipInfo = { error: "获取信息失败" };
      }
    },
    updateTooltipPosition(e) {
      this.tooltipStyle = {
        left: `${e.pageX + 10}px`,
        top: `${e.pageY + 10}px`
      };
    },
    handleMouseLeave(e) {
      var o;
      const t = e.relatedTarget;
      (o = this.$refs.tooltip) != null && o.contains(t) || (this.showTooltip = !1);
    },
    handleClickOutside(e) {
      var t;
      !((t = this.$refs.tooltip) != null && t.contains(e.target)) && !e.target.classList.contains("ip-highlight") && (this.showTooltip = !1);
    },
    formatValue(e) {
      return e == null ? "N/A" : typeof e == "object" ? Array.isArray(e) ? e.join(", ") || "N/A" : Object.entries(e).map(([t, o]) => `${t}: ${this.formatValue(o)}`).join(", ") || "N/A" : String(e);
    },
    observeDOMChanges() {
      new MutationObserver((t) => {
        t.forEach((o) => {
          o.addedNodes.length && this.highlightIPs();
        });
      }).observe(this.$el, {
        childList: !0,
        subtree: !0
      });
    }
  }
}, P = { class: "ip-highlighter" }, b = { class: "ip-tooltip-header" }, k = { class: "ip-tooltip-title" }, L = { class: "ip-tooltip-content" }, S = { class: "ip-tooltip-key" }, A = { class: "ip-tooltip-value" }, O = {
  key: 1,
  class: "ip-tooltip-row"
};
function R(e, t, o, i, s, r) {
  return p(), h("div", P, [
    v(e.$slots, "default", {}, void 0, !0),
    T(c("div", {
      class: "ip-tooltip",
      style: E(s.tooltipStyle),
      ref: "tooltip"
    }, [
      c("div", b, [
        c("h3", k, "IP: " + f(s.currentIP), 1)
      ]),
      c("div", L, [
        s.ipInfo ? (p(!0), h(y, { key: 0 }, w(s.ipInfo, (l, n) => (p(), h("div", {
          key: n,
          class: "ip-tooltip-row"
        }, [
          c("div", S, f(n) + ":", 1),
          c("div", A, f(r.formatValue(l)), 1)
        ]))), 128)) : (p(), h("div", O, "加载中..."))
      ])
    ], 4), [
      [x, s.showTooltip]
    ])
  ]);
}
const F = /* @__PURE__ */ C(N, [["render", R], ["__scopeId", "data-v-bedda146"]]), g = (e) => {
  g.installed || (g.installed = !0, e.component("ip-highlighter", F));
}, $ = {
  install: g,
  version: "1.0.3"
};
typeof window < "u" && window.Vue && window.Vue.use($);
export {
  F as IPHighlighter,
  $ as default
};
